/*------------------------------------------------------------------------------
--  This file is a part of the Uprobe Software
--  Copyright (C) 2014, Plasma Physics Laboratory - CNRS
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 2 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-------------------------------------------------------------------------------*/
/*--                  Author : Alexis Jeandet
--                     Mail : alexis.jeandet@member.fsf.org
--                    Author : Kaveh Mohamadabadi
--                     Mail : kaveh.mohamadabadi@lpp.polytechnique.fr
--------------------------------------------------------------------------------*/

#ifndef UCOMPORT_H
#define UCOMPORT_H

#include <QObject>
#include <RS232.h>
#include <QMutex>
#include <QMutexLocker>

class UComPort
{
public:
    explicit UComPort();

    QString portName();
    int speed();
    virtual void setPortName(const QString& name);
    virtual void setSpeed(int speed);

    virtual bool open();
    virtual bool open(const QString& name,int speed);
    virtual bool close();
    bool opened();
    int availableBytes();

    int readBytes(char* data,int count);
    int writeBytes(char* data,int count);

private:
    rs232port_t p_port;
    QString p_PortName;
    int p_speed;
    QMutex* p_portMutex;
    bool p_opened;

};

#endif // UCOMPORT_H
